// drweb-clamd API usage example.
// (C) 2003-2016 Doctor Web. All rights reserved.

#include <assert.h>
#include <signal.h>
#include <stdio.h>
#include <string.h>
#include <sys/socket.h>
#include <unistd.h>

#include "drweb_clamd_c_api_common.h"

const char* supported_cmds[] = { "SCAN", "INSTREAM", "FILDES", NULL };

int main(int argc, const char* argv[])
{
    signal(SIGPIPE, SIG_IGN);

    parsed_args_t args = {0};
    parse_args(argc, argv, &args);
    int clamd = connect_to_clamd(args.socket);

    const char* start_session_cmd = "nIDSESSION\n";
    write_exact(clamd, start_session_cmd, strlen(start_session_cmd));

    for(int i = 0; args.files[i] != NULL; ++i) {
        if(strcmp(args.cmd, "SCAN") == 0)
            scan(clamd, args.files[i], args.cmd);
        else if(strcmp(args.cmd, "INSTREAM") == 0)
            instream_scan(clamd, args.files[i]);
        else if(strcmp(args.cmd, "FILDES") == 0)
            fildes_scan(clamd, args.files[i]);
        else assert(0);

        char buf[4096];
        size_t n = read_until(clamd, '\n', buf, sizeof(buf) / sizeof(*buf));
        fwrite(buf, sizeof(char), n, stdout);
    }
    const char* end_session_cmd = "nEND\n";
    write_exact(clamd, end_session_cmd, strlen(end_session_cmd));

    shutdown(clamd, SHUT_RDWR);
    close(clamd);
    return 0;
}
